//-----------------------------------------------------------------------------
// File: DeviceWindows.cpp
//
// Copyright (c) Astralax. All rights reserved.
// Author: Sedov Alexey
//-----------------------------------------------------------------------------

#include "stdafx.h"
#include "DeviceWindows.h"
//#include "NetWindows.h"
#include "Game.h"
#include <float.h>
#include <math.h>

HWND hWnd=0;

char* szTitle="Onimod land";// The title bar text
char* szWindowClass="OnimodLand";			// the main window class name

#ifndef HID_USAGE_PAGE_GENERIC
#define HID_USAGE_PAGE_GENERIC         ((USHORT) 0x01)
#endif
#ifndef HID_USAGE_GENERIC_MOUSE
#define HID_USAGE_GENERIC_MOUSE        ((USHORT) 0x02)
#endif
#ifndef HID_USAGE_GENERIC_KEYBOARD
#define HID_USAGE_GENERIC_KEYBOARD     ((USHORT) 0x06)
#endif

//
//   : InitInstance(HINSTANCE, int)
//
//   :       .
//
//   :
//
//                ,  
//               .
//
HKL LocaleRU, LocaleEN;
BOOL InitInstance(HINSTANCE hInstance, int width, int height)
{
	//HWND hWnd;

	//hInst = hInstance; //      

	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	SetWindowLong(hWnd, GWL_STYLE, GetWindowLong(hWnd, GWL_STYLE) & (~WS_CAPTION));

	if (!hWnd)
	{
		return FALSE;
	}

	LocaleRU=LoadKeyboardLayoutA("00000419", KLF_ACTIVATE | KLF_REORDER | KLF_SUBSTITUTE_OK | KLF_SETFORPROCESS);
	LocaleEN=LoadKeyboardLayoutA("00000409", KLF_ACTIVATE | KLF_REORDER | KLF_SUBSTITUTE_OK | KLF_SETFORPROCESS);

	RAWINPUTDEVICE Rid[1];
	/*
	Rid[0].usUsagePage = HID_USAGE_PAGE_GENERIC; 
	Rid[0].usUsage = HID_USAGE_GENERIC_MOUSE; 
	Rid[0].dwFlags = RIDEV_INPUTSINK;   
	Rid[0].hwndTarget = hWnd;
	RegisterRawInputDevices(Rid, 1, sizeof(Rid[0]));
	*/
	
	//RAWINPUTDEVICE Rid[2];

	Rid[0].usUsagePage = HID_USAGE_PAGE_GENERIC;
	Rid[0].usUsage = HID_USAGE_GENERIC_KEYBOARD;
	Rid[0].dwFlags = RIDEV_INPUTSINK;
	Rid[0].hwndTarget = hWnd;

	//Rid[1].usUsagePage = HID_USAGE_PAGE_GENERIC;
	//Rid[1].usUsage = HID_USAGE_GENERIC_MOUSE;
	//Rid[1].dwFlags = RIDEV_INPUTSINK;
	//Rid[1].hwndTarget = hWnd;

	if (RegisterRawInputDevices(Rid, sizeof(Rid) / sizeof(RAWINPUTDEVICE), sizeof(Rid[0])) == FALSE)
		return false;



	unsigned int status=_controlfp(0,0);

	DEVMODE md;
	ZeroMemory(&md, sizeof(md));
	md.dmSize = sizeof(md);
	EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&md);

	_controlfp(status,_MCW_DN | _MCW_IC | _MCW_RC | _MCW_PC);

	if (width<=0)
		width=md.dmPelsWidth;
	if (height<=0)
		height=md.dmPelsHeight;

	int x=(md.dmPelsWidth-width)/2;
	int y=(md.dmPelsHeight-height)/2;
	MoveWindow(hWnd, x, y, width, height, true);

	//if (width==md.dmPelsWidth && height==md.dmPelsHeight)
	//	ShowWindow(hWnd, SW_MAXIMIZE);
	//else
	{
		ShowWindow(hWnd, SW_SHOW);
	}

	SetForegroundWindow(hWnd);
	SetActiveWindow(hWnd);

	UpdateWindow(hWnd);

	ShowCursor(false);

	return true;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (GDevice::game)
	{
		GDevice* device=GDevice::game->device;
		if (device)
			return ((GDeviceWindows*)(device))->WndProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	/*
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(0, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
	*/

	WNDCLASS wcl;
	ZeroMemory(&wcl, sizeof(wcl));
	
	wcl.style=CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wcl.lpfnWndProc	= WndProc;
	wcl.hInstance=hInstance;
	wcl.lpszClassName=szWindowClass;
	wcl.hIcon=LoadIcon(hInstance, "IDI_ICON");

	return RegisterClass(&wcl);
}

//     Windows   KEY
int GetKEY_From_VK(int kod)
{
	int key=-1;
	switch (kod)
	{
	case VK_LEFT: key=KEY_LEFT; break;
	case VK_RIGHT: key=KEY_RIGHT; break;
	case VK_UP: key=KEY_UP; break;
	case VK_DOWN: key=KEY_DOWN; break;
	case VK_HOME: key=KEY_HOME; break;
	case VK_OEM_PLUS: key=KEY_EQUALS; break;
	case VK_OEM_MINUS: key=KEY_MINUS; break;
	case VK_OEM_COMMA: key=KEY_COMMA; break;

	case VK_F1: key=KEY_F1; break;
	case VK_F2: key=KEY_F2; break;
	case VK_F3: key=KEY_F3; break;
	case VK_F4: key=KEY_F4; break;
	case VK_F5: key=KEY_F5; break;
	case VK_F6: key=KEY_F6; break;
	case VK_F7: key=KEY_F7; break;
	case VK_F8: key=KEY_F8; break;
	case VK_F9: key=KEY_F9; break;
	case VK_F10: key=KEY_F10; break;
	case VK_F11: key=KEY_F11; break;
	case VK_F12: key=KEY_F12; break;

	case VK_ESCAPE : key=KEY_ESCAPE; break ;
	case VK_SPACE : key=KEY_SPACE; break;
	case VK_END: key=KEY_END; break;
	case VK_RETURN : key=KEY_RETURN; break;
	case VK_DELETE: key=KEY_DELETE; break;
	case VK_BACK: key=KEY_BACK; break;

	case VK_TAB: key=KEY_TAB; break;
	case VK_SNAPSHOT: key=KEY_SYSRQ; break;
	case VK_OEM_3: key=KEY_GRAVE; break;

	case 'A': key=KEY_A; break;
	case 'B': key=KEY_B; break;
	case 'C': key=KEY_C; break;
	case 'D': key=KEY_D; break;
	case 'E': key=KEY_E; break;
	case 'F': key=KEY_F; break;
	case 'G': key=KEY_G; break;
	case 'H': key=KEY_H; break;
	case 'I': key=KEY_I; break;
	case 'J': key=KEY_J; break;
	case 'K': key=KEY_K; break;
	case 'L': key=KEY_L; break;
	case 'M': key=KEY_M; break;
	case 'N': key=KEY_N; break;
	case 'O': key=KEY_O; break;
	case 'P': key=KEY_P; break;
	case 'Q': key=KEY_Q; break;
	case 'R': key=KEY_R; break;
	case 'S': key=KEY_S; break;
	case 'T': key=KEY_T; break;
	case 'U': key=KEY_U; break;
	case 'V': key=KEY_V; break;
	case 'W': key=KEY_W; break;
	case 'X': key=KEY_X; break;
	case 'Y': key=KEY_Y; break;
	case 'Z': key=KEY_Z; break;
	
	case '0': key=KEY_0; break ;
	case '1': key=KEY_1; break ;
	case '2': key=KEY_2; break ;
	case '3': key=KEY_3; break ;
	case '4': key=KEY_4; break ;
	case '5': key=KEY_5; break ;
	case '6': key=KEY_6; break ;
	case '7': key=KEY_7; break ;
	case '8': key=KEY_8; break ;
	case '9': key=KEY_9; break ;

	case VK_CONTROL: key=KEY_LCONTROL; break;
	case VK_SHIFT: key=KEY_LSHIFT; break;
	case VK_MENU: key=KEY_LALT; break;

	default: key=-1;
	}
	return key;
}


GDeviceWindows::GDeviceWindows(bool fullscreen_mode, void* init) : GDevice(fullscreen_mode)
{
	this->hInstance=*((HINSTANCE*)init);
	hWnd=NULL;

	MyRegisterClass(this->hInstance);

	//cursor_x=width/2;
	//cursor_y=height/2;
	//SetCursorPos(cursor_x, cursor_y);
	
	//POINT cur;
	//GetCursorPos(&cur);
	//cursor_x=cur.x;
	//cursor_y=cur.y;

}

GDeviceWindows::~GDeviceWindows(void)
{
	if (started_mode.width)
		SetVideoMode(&started_mode);
}

/*
// 
void GDeviceWindows::ShowCursor()
{
	::ShowCursor(true);
}

void GDeviceWindows::HideCursor()
{
	::ShowCursor(false);
}
*/

//  
bool GDeviceWindows::Create(int view_width, int view_height)
{
	bool result=true;
	if (!hWnd)
	{
		if (view_width>0 || view_height>0)
			windowed=true;

		if (!InitInstance(hInstance, view_width, view_height))
		{
			result=false;

			win_cursor_x=width/2;
			win_cursor_y=height/2;
			SetCursorPos(win_cursor_x, win_cursor_y);
		}
	}

	if (result)
		result=GDevice::Create(view_width, view_height);

	return result;
}

//   
void GDeviceWindows::GetMonitorMode(VIDEO_MODE* vm)
{
	unsigned int status=_controlfp(0,0);

	DEVMODE md;
	ZeroMemory(&md, sizeof(md));
	md.dmSize = sizeof(md);
	EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&md);

	vm->width=md.dmPelsWidth;
	vm->height=md.dmPelsHeight;
	vm->bpp=md.dmBitsPerPel;

	_controlfp(status,_MCW_DN | _MCW_IC | _MCW_RC | _MCW_PC);
}

//    /
void GDeviceWindows::ChangeResolution(bool monitor, bool scene)
{
	if (monitor)
	{
		if (SetMonitorResolutionOnly())
		{
			if (platform)
			{
				if (platform->IsActivated())
				{
					MoveWindow(hWnd, 0, 0, monitor_width, monitor_height, true);
					//platform->ToMaximize();
				}
				/*
				else
				{	
					platform->ToIconic();
				}
				*/
			}
		}
	}
}

//      (    )
//    monitor_width, monitor_height
//    ,   
bool GDeviceWindows::SetMonitorResolutionOnly()
{
	VIDEO_MODE mm;
	GetMonitorMode(&mm);

	if (mm.width!=monitor_width || mm.height!=monitor_height)
	{
		unsigned int status=_controlfp(0,0);

		//    
		DEVMODE new_display_mode;
		ZeroMemory(&new_display_mode, sizeof(new_display_mode));
		new_display_mode.dmSize=sizeof(new_display_mode);
		new_display_mode.dmFields = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT | DM_DISPLAYFREQUENCY | DM_DISPLAYFLAGS;
		new_display_mode.dmBitsPerPel=32;
		new_display_mode.dmPelsWidth=monitor_width;
		new_display_mode.dmPelsHeight=monitor_height;
		new_display_mode.dmDisplayFrequency=0;
		new_display_mode.dmDisplayFlags=0;

		LONG ok=ChangeDisplaySettings(&new_display_mode, 0);
		if (ok!=DISP_CHANGE_SUCCESSFUL)
		{
			if (new_display_mode.dmDisplayFrequency)
			{
				new_display_mode.dmDisplayFrequency=0;
				ok=ChangeDisplaySettings(&new_display_mode, 0);
			}
		}
		
		_controlfp(status,_MCW_DN | _MCW_IC | _MCW_RC | _MCW_PC);
		return true;
	}
	return false;
}

//    
void GDeviceWindows::RefreshVideoMode()
{
	if (!k_mode)
	{
		//      
		DEVMODE md;
		ZeroMemory(&md, sizeof(md));
		md.dmSize = sizeof(md);
		md.dmFields = DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT|DM_DISPLAYFREQUENCY;
		BOOL fl_ok;
		int index_mode=0;
		unsigned int status=_controlfp(0,0);
		do
		{
			fl_ok=EnumDisplaySettings(NULL,index_mode,&md);
			VIDEO_MODE vm;
			vm.width=md.dmPelsWidth;
			vm.height=md.dmPelsHeight;
			vm.bpp=md.dmBitsPerPel;
			if (IsVideoMode(&vm))
			{
				int index=-1;
				for (int i=0;i<k_mode;i++)
				{
					if (m_mode[i]==vm)
					{
						index=i;
						break;
					}
				}
				if (index==-1)
				{
					m_mode[k_mode]=vm;
					k_mode++;
				}
			}
			index_mode++;
		}
		while(fl_ok);
		_controlfp(status,_MCW_DN | _MCW_IC | _MCW_RC | _MCW_PC);

		//   
		GDevice::RefreshVideoMode();
	}
}

//    (         )
bool GDeviceWindows::IsVisibleCursor()
{
	if (windowed)
	{
		RECT rect;
		GetWindowRect(hWnd, &rect);

		POINT cur;
		GetCursorPos(&cur);

		return (cur.x>=rect.left && cur.x<rect.right && cur.y>=rect.top && cur.y<rect.bottom);
	}
	return true;
}

//  
LRESULT GDeviceWindows::WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	//PAINTSTRUCT ps;
	//HDC hdc;

	switch (message)
	{
		/*
	case WM_PAINT:
		{
			hdc = BeginPaint(hWnd, &ps);
			EndPaint(hWnd, &ps);
			break;
		}
		
	case WM_ERASEBKGND:
		return 1;
		//break;
		*/

	case WM_CLOSE:
		GDevice::game->Quit();
		break;

	case WM_INPUT: 
		{
			if (game->IsActivated())
			{
				UINT dwSize = 40;
				static BYTE lpb[40];

				GetRawInputData((HRAWINPUT)lParam, RID_INPUT, 
					lpb, &dwSize, sizeof(RAWINPUTHEADER));

				RAWINPUT* raw = (RAWINPUT*)lpb;

				if (raw->header.dwType == RIM_TYPEMOUSE) 
				{
					if (!windowed)
					{
						int xPosRelative = raw->data.mouse.lLastX;
						int yPosRelative = raw->data.mouse.lLastY;
						game->PlatformMoveCursor(xPosRelative, yPosRelative);
					}
				}
				else
				{
					if (raw->header.dwType == RIM_TYPEKEYBOARD)
					{
						int key=GetKEY_From_VK(raw->data.keyboard.VKey);

						if (raw->data.keyboard.Flags & 1)
							game->PlatformKeyUp(key);
						else
							game->PlatformKeyDown(key, 0);
					}
				}
			}
			break;
		}

	case WM_MOUSEMOVE:
		{
			int x=LOWORD(lParam); //   
			int y=HIWORD(lParam); //  Y 

			int wi=tex_rect.right-tex_rect.left;
			int he=tex_rect.bottom-tex_rect.top;
			float kx=(float)width/(float)wi;
			float ky=(float)height/(float)he;
			if (windowed)
			{
				int vx=x-tex_rect.left;
				int vy=y-tex_rect.top;
				x=(int)(kx*vx);
				y=(int)(ky*vy);

				int cursor_x, cursor_y;
				game->GetCursorPosition(cursor_x, cursor_y);

				int rx=x-cursor_x;
				int ry=y-cursor_y;

				game->PlatformMoveCursor(rx, ry);
			}
			else
			{
				int vx=x-win_cursor_x;
				int vy=y-win_cursor_y;

				vx=(int)(kx*vx);
				vy=(int)(ky*vy);

				game->PlatformMoveCursor(vx, vy);

				win_cursor_x=x;
				win_cursor_y=y;

				float cx=monitor_width/2.f;
				float cy=monitor_height/2.f;
				float fx=(float)x;
				float fy=(float)y;
				float rx=fx-cx;
				float ry=fy-cy;
				float dist=sqrtf(rx*rx+ry*ry);
				if (dist>250)
				{
					win_cursor_x=monitor_width/2;
					win_cursor_y=monitor_height/2;
					SetCursorPos(win_cursor_x, win_cursor_y);
				}
			}
		}

		break;

		/*
	case WM_KEYDOWN:
		game->PlatformKeyDown(GetKEY_From_VK(wParam), 0);
		break;

	case WM_KEYUP:
		game->PlatformKeyUp(GetKEY_From_VK(wParam));
		break;
		*/

	//case WM_SYSKEYDOWN:
	//	game->PlatformKeyDown(GetKEY_From_VK(wParam));
	//	break;

	//case WM_SYSKEYUP:
	//	game->PlatformKeyUp(GetKEY_From_VK(wParam));
	//	break;

	case WM_CHAR:
		game->SysOnChar(wParam, 0, 0);
		break;

	case WM_LBUTTONDOWN:
		game->PlatformKeyDown(KEY_LMOUSE, 0);
		break;

	case WM_LBUTTONUP:
		game->PlatformKeyUp(KEY_LMOUSE);
		break;

	case WM_LBUTTONDBLCLK:
		game->SysOnLButtonDblClk();
		break;

	case WM_RBUTTONDOWN:
		game->PlatformKeyDown(KEY_RMOUSE, 0);
		break;

	case WM_RBUTTONUP:
		game->PlatformKeyUp(KEY_RMOUSE);
		break;

	case WM_RBUTTONDBLCLK:
		game->SysOnRButtonDblClk();
		break;

	case WM_MBUTTONDOWN:
		game->PlatformKeyDown(KEY_MMOUSE, 0);
		break;

	case WM_MBUTTONUP:
		game->PlatformKeyUp(KEY_MMOUSE);
		break;

	case WM_MBUTTONDBLCLK:
		game->SysOnMButtonDblClk();
		break;

	case WM_MOUSEWHEEL:
		{
			short zDelta=GET_WHEEL_DELTA_WPARAM(wParam);
			game->SysOnMouseWheel(zDelta);
		}
		break;

	case WM_TIMER:
		{
			TIMER_DATA* t=(TIMER_DATA*)wParam;
			GComponent* owner=t->owner;
			if (owner)
				owner->OnTimer(t->id);
			else
				game->PlatformTimer();
		}

		//if (wParam==0xfffe)
		//	game->PlatformTimer();
		//else
		//	game->OnTimer(wParam);
		break;

	case WM_ACTIVATE:
		{
			if (!windowed)
			{
				unsigned int fActive=LOWORD(wParam);           	//   
				bool fMinimized=false;
				if (HIWORD(wParam)) 	//   
					fMinimized=true;
				//hwndPrevious = (HWND) lParam;       	//   
				game->SysOnActivate(fActive, fMinimized);
			}
		}

		break;

	case WM_INPUTLANGCHANGE:
		{
			HKL hkl=(HKL)lParam;  
			//if ((hkl!=LocaleEN) & (hkl!=LocaleRU))
			//	 ActivateKeyboardLayout(HKL_NEXT, KLF_SETFORPROCESS);
			if (hkl==LocaleEN || hkl==LocaleRU)
				 ActivateKeyboardLayout(hkl, KLF_SETFORPROCESS);
			break;
		}

		/*
	case WM_SOCKET:
		if (game->net)
		{
			SOCKET sock=(SOCKET)wParam;
			//int min=sizeof(SEND_MESSAGE);
			int index=game->net->FindSocket((void*)sock);
			if (index!=-1)
			{
				NET_CLIENT* client=game->net->GetClient(index);
				GNetSocket* socket=client->socket;1

				switch (WSAGETSELECTEVENT(lParam))
				{
				case FD_READ: //  
					if (socket->IsTCP())
						socket->ReceiveTCP();
					else
						socket->ReceiveUPD();
					break;
				case FD_WRITE: //     
					if (socket->IsTCP())
						socket->SendTCP();
					else
						socket->SendUDP();
					break;
				case FD_CONNECT: //  
					//     
					{
						int len=game->net->PrepareMessage(CONNECTED_ID, MESSAGE_TYPE_CONNECTING, 0, NULL);
						socket->SendMessage(len, game->net->GetSendingBuffer());
					}
					break;
				case FD_ACCEPT: //  
					{
						SOCKET new_sock=(SOCKET)socket->Accept();
						GNetSocketWindows* sock_win=new GNetSocketWindows;
						sock_win->sock=new_sock;
						NET_CLIENT* client=new NET_CLIENT;
						client->socket=sock_win;
						game->net->ConnectClient(client);
						int len=game->net->PrepareMessage(CONNECTED_ID, MESSAGE_TYPE_ACCEPT_REPLY, 4, &(client->player_id));
						socket->SendMessage(len, game->net->GetSendingBuffer());
					}
					break;
				case FD_CLOSE: //  
					break;
				}
			}
		}
		break;
		*/

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}

	return 0;
}
