//-----------------------------------------------------------------------------
// File: DeviceWindows.h
//
// Copyright (c) Astralax. All rights reserved.
// Author: Sedov Alexey
//-----------------------------------------------------------------------------

#pragma once
#include "Graphics.h"

class GDeviceWindows :
	public GDevice
{
protected:
	HINSTANCE	hInstance;		// Holds The Instance Of The Application

	int win_cursor_x, win_cursor_y;

public:
	GDeviceWindows(bool fullscreen_mode, void* init);
	virtual ~GDeviceWindows(void);

	//  
	virtual bool Create(int view_width, int view_height);

	//    
	virtual void GetMonitorMode(VIDEO_MODE* vm);

	//    
	virtual void RefreshVideoMode();

protected:
	//    /
	virtual void ChangeResolution(bool monitor, bool scene);

	//      (    )
	//    monitor_width, monitor_height
	//    ,   
	virtual bool SetMonitorResolutionOnly();

public:
	//    (         )
	virtual bool IsVisibleCursor();

	//  
	LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
};
