//-----------------------------------------------------------------------------
// File: DeviceWindowsDX9.h
//
// Copyright (c) Astralax. All rights reserved.
// Author: Sedov Alexey
//-----------------------------------------------------------------------------

#pragma once
#include "DeviceWindows.h"
#include "../DX90SDK/Include/d3d9.h"
#include "../DX90SDK/Include/d3dx9tex.h"

#pragma comment (lib, "../Tools/DX90SDK/Lib/d3d9.lib")
#pragma comment (lib, "../Tools/DX90SDK/Lib/d3dx9.lib")

//#define BACKBUFFER_SCREEN	//         

#define FVF_PARTICLE (D3DFVF_XYZRHW | D3DFVF_TEX1)

struct VERTEX_PARTICLE
{
	float x, y, z;		// eng: coordinates
	// rus: 
	float rhw;

	float u, v;			// eng: textural coordinates
	// rus:  
};

class GDeviceWindowsDX9 :
	public GDeviceWindows
{
protected:
	LPDIRECT3D9 direct_3d;
	LPDIRECT3DDEVICE9 device_3d;

	#ifdef BACKBUFFER_SCREEN
	//LPDIRECT3DSURFACE9 back_surface;
	#else
	LPDIRECT3DVERTEXBUFFER9 vertex_buffer;
	#endif
	LPDIRECT3DTEXTURE9 texture;

public:
	GDeviceWindowsDX9(bool fullscreen_mode, void* init);
	virtual ~GDeviceWindowsDX9(void);

	LPDIRECT3DDEVICE9 GetDevice(){return device_3d;}

	//      
	virtual void GetMinSize(int& min_width, int& min_height){min_width=800; min_height=600;}
	virtual void GetMaxSize(int& max_width, int& max_height){max_width=100000; max_height=100000;}

	//  
	virtual void Destroy();

	void DestroyTexture();
	void DestroyDirect3D();

	//  
	//virtual GSurface* NewSurface();

	//   
	virtual void GetSceneRect(CMagicRect* rect);

	//    
	virtual void RefreshVideoMode();

	//   
	virtual void GetMonitorMode(VIDEO_MODE* vm);

protected:
	//    /
	void ChangeResolution(bool monitor, bool scene);

	//      (    )
	//    monitor_width, monitor_height
	//    ,   
	virtual bool SetMonitorResolutionOnly();

public:
	virtual void LockBackbuffer(SURFACE_LOCKED* locked);
	virtual void UnlockBackbuffer();

	//    
	virtual void GetScreenModeDefault(VIDEO_MODE* vm);

	//   
	virtual bool IsLost();

	// 
	virtual void Render();

	//  
	//virtual void Activate();

	//  
	virtual void Inactivate();
};
