//-----------------------------------------------------------------------------
// File: Surface16.h
//
// Copyright (c) Astralax. All rights reserved.
// Author: Sedov Alexey
//-----------------------------------------------------------------------------

#ifndef ONIMOD_SURFACE16
#define ONIMOD_SURFACE16

#include "Graphics.h"

class GSurface16 : public GSurface
{
public:
	GSurface16();

	//    
	virtual void Clear(unsigned int color);

	//    
	virtual void FillRect(int x, int y, int width, int height, unsigned int color);

	//   
	virtual void DrawHorizontalLine(int x, int y, int length, unsigned int color);
	//   
	virtual void DrawVerticalLine(int x, int y, int length, unsigned int color);

	//  
	void DrawLine(int x1, int y1, int x2, int y2, unsigned int color);

	//   
	void FloodFill(int x, int y, unsigned int fill_color, unsigned int obstacle_color);
	
	//      ,    -
	void MaskTransparentPixel(int position);

	//   RGB 
	virtual void GetPixelRGB(int x, int y, SURFACE_RGB* rgb);

	//   RGB 
	virtual void SetPixelRGB(int x, int y, SURFACE_RGB* rgb);

	//   Alpha 
	float GetPixelAlpha(int x, int y);

	//   
	virtual int GetBPP();

	//      
	virtual bool IsOver(int x, int y);

protected:
	//     SURFACE_LOCKED
	//void BltOperation(SURFACE_LOCKED* to_lock, int x, int y, int x_from, int y_from, int width, int height, bool transparent);

public:
	//      
	//virtual bool Blt(GSurface* from, int x=0, int y=0, int x_from=0, int y_from=0, int width=0, int height=0, bool transparent=true);

	//     
	virtual void BltSymbol(SYMBOL* symbol, int x, int y, unsigned int color, unsigned int color_transparent=COLOR_KEY_EMPTY);

	//    -    (     )
	virtual bool Copy(GSurface* from, int x, int y);

	//  
	virtual void CopyPixel(void* from, void* to);

	//   32-        (-  )
	//     to_x, to_y.     width, height    
	virtual void BltVideo(unsigned int* from, int to_x, int to_y, int from_x, int from_y, int width, int height, int pitch=0);

	//       R,G,B
	virtual void PixelToRgb(void* color_ptr, SURFACE_RGB* rgb);
	//    R,G,B  
	virtual void RgbToPixel(SURFACE_RGB* rgb, void* color_ptr);

	//      
	// ,      
	virtual void CopyToTexture32(void* texture_ptr, int texture_pitch);

	//         
	// ,      
	virtual void CopyToTexture(void* texture_ptr, int texture_pitch);

protected:
	//      
	virtual void BltHorizontalLine(BLT_LINE_DATA* data);
	//      
	virtual void BltHorizontalLineRev(BLT_LINE_DATA* data);
};

#endif