#pragma once

#include "..\Game.h"

#define SOUND_NO		-1
#define SOUND_PLAY		0
#define SOUND_PAUSE		1
//#define SOUND_PREPARED	2

class GSoundChannel
{
public:
	static GSound* sound;

public:
	virtual void Stop()=0;

	virtual void SetVolume(float volume)=0;
	virtual void SetVolume(int volume)=0;

	virtual void SetMaxPriority()=0;

	virtual int GetState()=0;

	virtual int GetPosition()=0;
};

class GSoundSample
{
public:
	static GSound* sound;

public:
	virtual bool LoadFromMemory(FILE_DATA& fd)=0;
	virtual void Unload()=0;

	virtual GSoundChannel* Play(bool loop, int volume)=0;
};

class GSound
{
protected:
	int k_sample;
	GSoundSample** m_sample;

	int k_channel;
	GSoundChannel** m_channel;

public:
	GSound(void);
	virtual ~GSound(void);

	virtual GSoundSample* NewSample()=0;

	int LoadFromMemory(FILE_DATA& fd);
	bool Unload(int sample);

	int Play(int sample, float volume, bool loop=false);
	int Play(int sample, int volume, bool loop=false);
	bool Stop(int channel);

	bool SetVolume(int channel, float volume);
	bool SetVolume(int channel, int volume);

	bool SetMaxPriority(int channel);

	int GetState(int channel);

	int GetPosition(int channel);

	//       0  1     
	virtual int CalcVolume(float volume)=0;

protected:
	int AddSample(GSoundSample* sample);
	int AddChannel(GSoundChannel* channel);

	GSoundSample* GetSample(int sample);
	GSoundChannel* GetChannel(int channel);

};
