#ifdef STEAM

#include "SteamLicense.h"
#include "../Game.h"

#pragma comment(lib, "steam_api.lib")

//  Steam-
int InitSteam()
{
	if (!SteamAPI_RestartAppIfNecessary(k_uAppIdInvalid))
	{
		//if (Steamworks_InitCEGLibrary())
		{
			SteamAPI_Init();
			ISteamUser* iuser=SteamUser();
			if (iuser)
			{
				if (iuser->BLoggedOn())
				{
					return 1;
				}
			}
		}
	}
	return 0;
}

//  Steam-
void CloseSteam()
{
	SteamAPI_Shutdown();
}

//  
bool CheckLicense(GGame* game, const char* lic)
{
	CSteamID user_id=SteamUser()->GetSteamID();
	unsigned int id=user_id.GetAccountID();
	if (lic)
	{
		//   - 
		CMagicString license=lic;
		int lic_id=license.StringToInt();
		unsigned int uid=lic_id;
		if (lic_id<0)
		{
			uid=uid ^ (-1);
			uid++;
		}

		if (uid==id)
			return true;
	}

	//CSteamID steam_id=SteamUser()->GetSteamID();

	//steam_id.


	EUserHasLicenseForAppResult result=SteamUser()->UserHasLicenseForApp(user_id, game->GetGameSteamID());
	if (result==k_EUserHasLicenseResultHasLicense)
	{
		//   
		CMagicString license;
		license.IntToString(id);
		game->SaveLicense(license);
		return true;
	}
	return false;
}

#endif