//       OGG/Theora
#include "video.h"
#include "..\Graphics.h"
#include "..\Game.h"

#pragma comment(lib, "libtheora.lib")
#pragma comment(lib, "libogg.lib")

//---------------------------------------------------------------------------
/*
int get_data_from_physical_stream(FILE *INFILE_, ogg_sync_state *OGG_SYNC_STATE_)
{
	const int DBS__=8192;
	char *buffer=ogg_sync_buffer(OGG_SYNC_STATE_,DBS__); //     
	
	long bytes=fread(buffer,1,DBS__,INFILE_); //  
	
	ogg_sync_wrote(OGG_SYNC_STATE_,bytes); //,        (..    -   !)
	
	return bytes; //,  
}


int get_data_from_physical_stream(CMagicStream* INFILE_, ogg_sync_state *OGG_SYNC_STATE_)
{
	const int DBS__=8192;
	char *buffer=ogg_sync_buffer(OGG_SYNC_STATE_,DBS__); //     

	long bytes=INFILE_->Read(buffer, DBS__); //  

	ogg_sync_wrote(OGG_SYNC_STATE_,bytes); //,        (..    -   !)

	return bytes; //,  
}
*/

//---------------------------------------------------------------------------------

GVideo::GVideo()
{
	name="";
	current_frame=0;
	
	start_time=0;
	frame_time=0;

	currentfile=NULL;
	stream=NULL;
	frame=NULL;

	//texture=0;
	ScreenWidth=0;
	ScreenHeight=0;

	for(signed int cc=0; cc<256; cc++)
	{
		b0_[cc] = ( 113443 * (cc-128) + 32768 ) >> 16;
	}

	for(signed int cc=0; cc<256; cc++)
	{
		b1_[cc] = (  45744 * (cc-128) + 32768 ) >> 16;
	}

	for(signed int cc=0; cc<256; cc++)
	{
		b2_[cc] = (  22020 * (cc-128) + 32768 ) >> 16;
	}

	for(signed int cc=0; cc<256; cc++)
	{
		b3_[cc] = ( 113508 * (cc-128) + 32768 ) >> 16;
	} 
}

GVideo::~GVideo()
{
	Close();
}

//  
GVideo& GVideo::GetInstance()
{
	static GVideo video;
	return video;
}

//       
bool GVideo::OpenFile(CMagicString file_name, int rate)
{
	if (!IsClosed())
	{
		//    
		Close();
	}

	GPlatform* platform=GSurface::device->platform;
	currentfile=platform->OpenFile(file_name.c_str(),"rb");
	if(currentfile==NULL)
	{
		printf("%s", "cannot open ogg-file");
		assert(false);
		return false;
	}
	Init(rate);
	name=file_name;
	return true;
}

//       
bool GVideo::OpenStream(CMagicString file_name, int rate)
{
	if (!IsClosed())
	{
		//    
		Close();
	}

	GPlatform* platform=GSurface::device->platform;
	stream=platform->OpenStream(file_name);
	if(stream==NULL)
	{
		printf("%s", "cannot open ogg-file");
		assert(false);
		return false;
	}
	Init(rate);
	name=file_name;
	return true;
}


//   
bool GVideo::Init(int rate)
{
	//   ogg/theora:
	memset(&OGG_STREAM_STATE_THEORA, 0x00, sizeof(ogg_stream_state));
	memset(&OGG_SYNC_STATE, 0x00, sizeof(ogg_sync_state));
	memset(&OGG_PAGE, 0x00, sizeof(ogg_page));
	memset(&OGG_PACKET, 0x00, sizeof(ogg_packet));

	memset(&THEORA_COMMENT, 0x00, sizeof(theora_comment));
	memset(&THEORA_INFO, 0x00, sizeof(theora_info));
	memset(&THEORA_STATE, 0x00, sizeof(theora_state));
	memset(&YUV_BUFFER, 0x00, sizeof(yuv_buffer));

	

	//    ogg
	memset(&OGG_STREAM_STATE_THEORA, 0x00, sizeof(ogg_stream_state));
	ogg_stream_clear(&OGG_STREAM_STATE_THEORA);
/*
	if (ogg_stream_init(&OGG_STREAM_STATE_THEORA, 1)  !=0)
	// 1   ,      
		throw std::runtime_error("error during ogg_stream_init");
//*/
	// " " ogg
	ogg_sync_init(&OGG_SYNC_STATE);

	//       
	theora_comment_init(&THEORA_COMMENT);
	theora_info_init(&THEORA_INFO);

	//      theora
	bool START_THEORA_HEADER_STREAM=true;
	int THEORA_HEADER_PACKETS=0;	//    theora

	do
	{
		//if( get_data_from_physical_stream(currentfile, &OGG_SYNC_STATE) ==0)
		if (ReadVideo()==0)
		{
			printf("%s", "eof searched, terminate...");	// ,     
			assert(false);
			return false;
		}

		//ogg_sync_pageout -  
		while( ogg_sync_pageout(&OGG_SYNC_STATE, &OGG_PAGE) >0)
			//1-   
			//0-     
		{

			//   

			//   ?  ,   
			if( ogg_page_bos(&OGG_PAGE) ==false)
			{
				//,    
				//,           
				//       

				//     
				push_page_into_logical_stream(&OGG_PAGE);
				//push_page_into_logical_stream -      theora, 
				//   
				//    

				//  
				START_THEORA_HEADER_STREAM=false;
				break;
			}
			else
			{
				//,   

				//  
				ogg_stream_state OGG_STREAM_STATE_TEST;
				memset(&OGG_STREAM_STATE_TEST, 0x00, sizeof(ogg_stream_state));

				//THEORA_HEADER_PACKETS -     theora ( )
				//  theora     
				if(THEORA_HEADER_PACKETS==0)
				{
				//           ,     
				if(0!= ogg_stream_init(&OGG_STREAM_STATE_TEST,ogg_page_serialno(&OGG_PAGE)) )
				{
					printf("%s", "error during ogg_stream_init");
					assert(false);
					return false;
				}
			
				//    
				if(0!= ogg_stream_pagein(&OGG_STREAM_STATE_TEST,&OGG_PAGE) )
				{
					printf("%s", "error during ogg_stream_pagein");
					assert(false);
					return false;
				}

				//       
				if( ogg_stream_packetout(&OGG_STREAM_STATE_TEST,&OGG_PACKET) ==-1)
				{
					printf("%s", "error during ogg_stream_packetout");
					assert(false);
					return false;
				}


					int dhr=theora_decode_header(&THEORA_INFO,&THEORA_COMMENT,&OGG_PACKET);
					//  theora

					if(dhr<0)
					{
						//   theora
							
						//   
						ogg_stream_clear(&OGG_STREAM_STATE_TEST);
						//      theora
					}
					else
					{
						//  theora!

						//   ""   theora:
						memcpy(&OGG_STREAM_STATE_THEORA, &OGG_STREAM_STATE_TEST, sizeof(OGG_STREAM_STATE_TEST));
						//        theora

						THEORA_HEADER_PACKETS++;

						// ,        theora,
						//        
						//   ( , , )
					}
				}
				/*else
				{
					//      theora, 

					ogg_stream_clear(&OGG_STREAM_STATE_TEST);
				}//*/
			}
		}

	}
	while(START_THEORA_HEADER_STREAM);

	//  :
	//1)     theora,     theora 
	//2)    OGG_STREAM_STATE_THEORA

	//       theora (. )  
	//   

	while(THEORA_HEADER_PACKETS<3)
	{
			int result=ogg_stream_packetout(&OGG_STREAM_STATE_THEORA,&OGG_PACKET);
			//   ,      
			//      libogg,    

			if(result<0)
			{
				// ,  
				printf("%s", "error during ogg_stream_packetout");
				assert(false);
				return false;
			}

			if(result>0)
			{
				//     theora

				int result2=theora_decode_header(&THEORA_INFO,&THEORA_COMMENT,&OGG_PACKET);

				if(result2<0)
				{
					// ,  
					printf("%s", "error during theora_decode_header (corrupt stream)");
					switch (result2)
					{
					case OC_BADHEADER:
						printf("%s", "OC_BADHEADER");
						break;

					case OC_VERSION:
						printf("%s", "OC_VERSION");
						break;

					case OC_NEWPACKET:
						printf("%s", "OC_NEWPACKET");
						break;
					}
					assert(false);
					return false;
				}

				++THEORA_HEADER_PACKETS;
			}

		//  ,   
		//    ,    - 
		// .   ,       :

		if( ogg_sync_pageout(&OGG_SYNC_STATE,&OGG_PAGE) >0)
			//ogg_sync_pageout - ,      ogg     ogg_page
		{
			//     ...
			push_page_into_logical_stream(&OGG_PAGE);
			//...     
		}
		else
		{
			//     
			//int ret=get_data_from_physical_stream(currentfile,&OGG_SYNC_STATE);
			int ret=ReadVideo();
			//  !    
			
			if(ret==0)
			{
				//  !
				printf("%s", "eof searched. terminate...");
				assert(false);
				return false;
			}
		}
	}

	//   , ,  .  

	// -
	theora_decode_init(&THEORA_STATE,&THEORA_INFO);
	//report_colorspace(&THEORA_INFO);
	//dump_comments(&THEORA_COMMENT);

	//    

	//   ,    
	frame_time=(double(1000))/rate;
	current_frame=0;
	
	//    
	Update();

	return true;
}
	
//  
void GVideo::Close()
{
	if (!IsClosed())
	{
		//...
		theora_clear(&THEORA_STATE);
		theora_comment_clear(&THEORA_COMMENT);
		theora_info_clear(&THEORA_INFO);

		ogg_stream_clear(&OGG_STREAM_STATE_THEORA);
		ogg_sync_clear(&OGG_SYNC_STATE);

		// 
		delete[] frame;
		frame=NULL;

		//   ogg/theora:
		memset(&OGG_STREAM_STATE_THEORA, 0x00, sizeof(ogg_stream_state));
		memset(&OGG_SYNC_STATE, 0x00, sizeof(ogg_sync_state));
		memset(&OGG_PAGE, 0x00, sizeof(ogg_page));
		memset(&OGG_PACKET, 0x00, sizeof(ogg_packet));

		memset(&THEORA_COMMENT, 0x00, sizeof(theora_comment));
		memset(&THEORA_INFO, 0x00, sizeof(theora_info));
		memset(&THEORA_STATE, 0x00, sizeof(theora_state));
		memset(&YUV_BUFFER, 0x00, sizeof(yuv_buffer));

		if (currentfile)
		{
			fclose(currentfile);
			currentfile=NULL;
		}

		if (stream)
		{
			delete stream;
			stream=NULL;
		}

		name="";
		current_frame=0;
	}
}

bool GVideo::IsClosed()
{
	return (name.IsEmpty());
}

//    
int GVideo::ReadVideo()
{
	const int DBS__=8192;
	char *buffer=ogg_sync_buffer(&OGG_SYNC_STATE,DBS__); //     

	long bytes;
	if (stream)
		bytes=stream->Read(buffer, DBS__); //  
	else
		bytes=fread(buffer,1,DBS__, currentfile); //  

	ogg_sync_wrote(&OGG_SYNC_STATE,bytes); //,        (..    -   !)

	return bytes; //,  
}

//     
void GVideo::Render(GSurface* surface)
{
	if (name!="")
	{
		int wi, he;
		surface->GetSize(wi, he);
		int x=(wi-THEORA_INFO.frame_width)/2;
		int y=(he-THEORA_INFO.frame_height)/2;

		surface->BltVideo((unsigned int*)frame, x, y, THEORA_INFO.offset_x, THEORA_INFO.offset_y, THEORA_INFO.frame_width, THEORA_INFO.frame_height, THEORA_INFO.width);
	}
}

//      
bool GVideo::Update()
{
	if (!IsClosed())
	{
		//   
		GPlatform* platform=GSurface::device->platform;
		int count_frame=0;
		if (current_frame)
		{
			//        
			unsigned int now_time=platform->GetTick();
			unsigned int razn=now_time-start_time;

			count_frame=(int)(((double)razn)/frame_time);
			count_frame-=current_frame;

			if (count_frame<=0)
				return false;

			if (count_frame>1)
				count_frame=1;
		}
		else
		{
			//    
			start_time=platform->GetTick();
			count_frame=1;
		}

		for (int i=0;i<count_frame;i++)
		{
			//theora processing...
			while( ogg_stream_packetout(&OGG_STREAM_STATE_THEORA,&OGG_PACKET) <=0)
			{
				//      theora
				//           

				//int ret=get_data_from_physical_stream(currentfile,&OGG_SYNC_STATE);	//   
				int ret=ReadVideo();
				if(ret==0)
				{
					// ,        
					Close();
					return false;
				}

				while( ogg_sync_pageout(&OGG_SYNC_STATE,&OGG_PAGE) >0)
					//      (ogg_page)      
				{
					push_page_into_logical_stream(&OGG_PAGE);	//    .  
				}
			}

			current_frame++;
			if (i!=count_frame-1)
				continue;

			// .     ogg-
			//(   theora-)

			//    theora
			if(OC_BADPACKET== theora_decode_packetin(&THEORA_STATE,&OGG_PACKET) )	//RTC check fails here
			{
				// 
				printf("%s", "error during theora_decode_packetin...");
				assert(false);
			}

			//  ,  

			//   YUV-  .  yuv_buffer
			if(0!= theora_decode_YUVout(&THEORA_STATE,&YUV_BUFFER) )
			{
				// 
				printf("%s", "error during theora_decode_YUVout...");
				assert(false);
			}

			if (!frame)
			{
				//    
				frame=new BYTE[YUV_BUFFER.y_height*YUV_BUFFER.y_width*4];
			}

			for ( int nTempY = 0; nTempY < YUV_BUFFER.y_height; nTempY++ )
			{
				int nYShift = YUV_BUFFER.y_stride * nTempY;
				int nUVShift = YUV_BUFFER.uv_stride * ( nTempY >> 1 );
				
				for ( int nTempX = 0; nTempX < YUV_BUFFER.y_width; nTempX++ )
				{
					int nHX = ( nTempX >> 1 );

					BYTE nY = *(BYTE*)( YUV_BUFFER.y + nYShift + nTempX );
					BYTE nU = *(BYTE*)( YUV_BUFFER.u + nUVShift + nHX );
					BYTE nV = *(BYTE*)( YUV_BUFFER.v + nUVShift + nHX );

					int index=(nTempY*YUV_BUFFER.y_width+nTempX)*4;

					int r = nY + b0_[nV];
					int g = nY - b1_[nV] - b2_[nU];
					int b = nY + b3_[nU];

					frame[index+2]= b>255?b=255:b<0?b=0:b;
					frame[index+1]= g>255?g=255:g<0?g=0:g;
					frame[index]= r>255?r=255:r<0?r=0:r;
					frame[index+3]= r<25&&g<25&&b<25?0:255; 
				}
			}

			/*
			//  
			for (int k=0;k<YUV_BUFFER.y_height/2;k++)
			{
				int* line1=(int*)(&(frame[k*YUV_BUFFER.y_width*4]));
				int* line2=(int*)(&(frame[(YUV_BUFFER.y_height-k-1)*YUV_BUFFER.y_width*4]));
				for (int l=0;l<YUV_BUFFER.y_width;l++)
				{
					int v=*line1;
					*line1=*line2;
					*line2=v;
					line1++;
					line2++;
				}
			}
			*/
		}
		return true;
	}
	return false;
}

//       
bool GVideo::IsPause()
{
	if (name!="")
		return true;
	return false;
}

//   
void GVideo::SetScreenSize(int wi,int he)
{
	ScreenWidth=wi;
	ScreenHeight=he;
}

//,     
int GVideo::push_page_into_logical_stream(ogg_page *page)
{
	if(-1== ogg_stream_pagein(&OGG_STREAM_STATE_THEORA,page) )
	{
		//__asm nop;	//,             (    theora   vorbis)
	}

	return 0;
}
//---------------------------------------------------------------------------------

