#ifndef _GLEST_GAME_VIDEO_H_
#define _GLEST_GAME_VIDEO_H_

#include "..\utils.h"

extern "C"
{
	#include <ogg/ogg.h>
	#include <theora/theora.h>
}

class GSurface;

class GVideo
{
	CMagicString name;
	int current_frame;
	
	unsigned int start_time;
	double frame_time;

	FILE* currentfile;
	CMagicStream* stream;
	unsigned char* frame;

	//unsigned int texture;
	int ScreenWidth;
	int ScreenHeight;

	ogg_stream_state OGG_STREAM_STATE_THEORA;
	ogg_sync_state OGG_SYNC_STATE;
	ogg_page OGG_PAGE;
	ogg_packet OGG_PACKET;

	theora_comment THEORA_COMMENT;
	theora_info THEORA_INFO;
	theora_state THEORA_STATE;

	yuv_buffer YUV_BUFFER;

	int b0_[256];
	int b1_[256];
	int b2_[256];
	int b3_[256];

public:
	GVideo();
	virtual ~GVideo();

	//  
	static GVideo& GetInstance();

	//       
	bool OpenFile(CMagicString file_name, int rate);
	//       
	bool OpenStream(CMagicString file_name, int rate);
	
	//  
	void Close();

	//  ,    
	bool IsClosed();

	//    
	int ReadVideo();

	//     
	void Render(GSurface* surface);

	//      
	bool Update();

	//       
	bool IsPause();

	//   
	void SetScreenSize(int wi,int he);

private:
	//,     
	int push_page_into_logical_stream(ogg_page *page);

	//   
	bool Init(int rate);
};

#endif